// C Source File
// Created 12/24/2006 09:09:31 PM

#include <tigcclib.h>
#include "main.h"

//uses the z-coord to alter the x and y coords to make the model appear 3D
vertex_3d add_depth(vertex_3d *vertex,long addz) {
		long newx=(vertex->x-((TI89?79:119)<<8));
		long newy=(vertex->y-((TI89?49:63)<<8));
		long newz=vertex->z+addz;
		
		
		//vertices need to approach x=79;y=80
		
		return (vertex_3d){(newx/newz)+(TI89?79:119),(newy/newz)+(TI89?49:63),newz};
		
}



vertex_3d pointrot_3d(long x, long y, long z, long centerx, long centery, long centerz, short rotx, short roty, short rotz) {
		long newx=x-centerx;
		long newx1=newx;
		long newy=y-centery;
		long newy1;
		long newz=z-centerz;
		
		//each new rotation must use the new coords from the last rotation
		
		//rotate about the z-axis
		
		newx=((newx*sin128(90+rotz))-(newy*sin128(-rotz)))>>7;
		newy=((newx1*sin128(-rotz))+(newy*sin128(90+rotz)))>>7;
		
		newy1=newy;
		
		//rotate about the x-axis
		newy=((newy*sin128(90-rotx))-(newz*sin128(rotx)))>>7;
		newz=((newy1*sin128(rotx))+(newz*sin128(90-rotx)))>>7;
		
		newx1=newx;
		
		//rotate about the y-axis
		newx=((newx*sin128(90+roty))-(newz*sin128(-roty)))>>7;
		newz=((newx1*sin128(-roty))+(newz*sin128(90+roty)))>>7;

		
		return (vertex_3d){newx+centerx,newy+centery,(newz+centerz)>>8};
}


void DrawModel(model *model, short xscale, short yscale, short zscale, short rotx, short roty, short rotz, long addx, long addy, long addz) {
		vertex_3d newvertices[model->num_vertices]; //locations of changed vertices
		short i=0;
		
		//calculate new positions after scaling/rotation
		for(;i<model->num_vertices;i++) {
				newvertices[i]=pointcalc_3d(model->vertices[i].x,model->vertices[i].y,model->vertices[i].z,
				model->centerx,model->centery,model->centerz,xscale,yscale,zscale,rotx,roty,rotz);
				
				//calculate screen coords to draw to
				newvertices[i]=add_depth(&newvertices[i],addz);
		}
		
		
		

		
		//connect the dots :)
		for(i=0;i<model->num_sides;i++) {
			DrawClipLine(&(const WIN_RECT){newvertices[model->sides[i].vertex0].x,newvertices[model->sides[i].vertex0].y,
			newvertices[model->sides[i].vertex1].x,newvertices[model->sides[i].vertex1].y},&(const SCR_RECT){{0,0,239,127}}
			,A_NORMAL);
		}
		
}


















